# norootforbuild
%global pkg lpfc
%global kernel 5.10.134-17.an8
%define pkg_version 14.2.673.37
%define anolis_release 9

%global debug_package %{nil}

Name:    kmod-%{pkg}
Version: %(echo %{kernel} | sed -E 's/-/~/g; s/\.(an|al)[0-9]+$//g')
Release: %{pkg_version}~%{anolis_release}%{?dist} 
License: GPL-2.0
Group: System/Kernel
Summary: Broadcom - Emulex lpfc driver for Fibre Channel HBAs
Vendor: Broadcom Inc. or its subsidiaries
Source: kmod-%{pkg}-%{pkg_version}.tar.gz

BuildRoot: %{_tmppath}/%{name}-%{version}-build
BuildRequires:    kernel-devel   = %{kernel}
BuildRequires:    kernel-headers = %{kernel}
BuildRequires:  elfutils-libelf-devel

Requires: dracut
Requires: kmod

%description
Broadcom - Emulex lpfc Linux kernel driver module.
For Emulex branded HBAs, Linux driver sources are available at:
https://www.broadcom.com/support/emulex
For OEM HBAs, contact the vendor.
The GPG Public Key of digitally signed Emulex device drivers is located in:
https://www.broadcom.com/docs/1334566.

%prep
rm -rf %{buildroot}
%setup -n kmod-%{pkg}-%{pkg_version}

%build
make -C /usr/src/kernels/%{kernel}.%{_arch}/ M=$PWD/src -j32

%install
mkdir -p %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/drivers/scsi/%{pkg}
make -C /usr/src/kernels/%{kernel}.%{_arch}/  KERNELVERSION=%{kernel}.%{_arch} INSTALL_MOD_PATH=%{buildroot} INSTALL_MOD_DIR=/extra/drivers/scsi/%{pkg} M=$PWD/src modules_install
# Make .ko objects temporarily executable for automatic stripping
find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+

# Cleanup unnecessary kernel-generated module dependency files.
find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;

install -m 644 -D %{pkg}.conf %{buildroot}/etc/depmod.d/lpfc.conf
install -m 644 -D %{pkg}_dracut.conf %{buildroot}/etc/dracut.conf.d/lpfc.conf
for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
    echo "override $(basename $kmod .ko) * extra/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
done

%clean
rm -rf %{buildroot}

%post
depmod -a > /dev/null 2>&1

if [ -x "/usr/sbin/weak-modules" ]; then
    printf '%s\n' "/lib/modules/%{kernel}.%{_arch}/extra/drivers/scsi/%{pkg}/%{pkg}.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
fi

%preun
echo "/lib/modules/%{kernel}.%{_arch}/extra/drivers/scsi/%{pkg}/%{pkg}.ko" >> /var/run/rpm-%{pkg}-modules.list

%postun
depmod -a > /dev/null 2>&1

if [ -x "/usr/sbin/weak-modules" ]; then
    modules=( $(cat /var/run/rpm-%{pkg}-modules.list) )
    printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --no-initramfs --remove-modules
fi
rm /var/run/rpm-%{pkg}-modules.list


%files
%defattr(644,root,root,755)
%license licenses/COPYING
/lib/modules/%{kernel}.%{_arch}
%config(noreplace) %{_sysconfdir}/depmod.d/%{pkg}.conf
%config(noreplace) %{_sysconfdir}/dracut.conf.d/%{pkg}.conf

%%changelog
* Fri Jul 19 2024 daichx <daichx@inspur.com> - 14.2.673.37
- init lpfc
